Attribute VB_Name = "Allgemein"
Option Explicit

Global FromIDE As Boolean

Global AppPath As String

Global BaudRaten As Variant
Global BaudRatenIdx As Variant

Global lang As Long  '0=D; 1=E; 2=Sloven.
Global strRegName As String

Global strFileFilter As String

'Global Const strCommString As String = "1200,n,7,2"
Global g_ComPort As Long
Global g_BPS As Long

Global g_BaudIdx As Long

Global g_DeviceIdx As Long
Global g_InputLen As Long


Global blnComIsOpen As Boolean

Global strPrinterName As String

Global blnColored As Boolean


Declare Function GetSystemDefaultLangID Lib "kernel32" () As Integer
Public Declare Function GetTickCount Lib "kernel32" () As Long




Sub Main()

  On Error Resume Next
    Debug.Print (1 / 0);
    If Err <> 0 Then
      FromIDE = True
    Else
      FromIDE = False
    End If
  On Error GoTo 0

  
  AppPath = RemoveEndingBackslash(App.Path)
  
  
  BaudRaten = Array(600, 1200, 2400, 4800, 9600)
  BaudRatenIdx = Array(6, 7, 9, 10, 12)
  
  On Error Resume Next
  
    'Call OutputDebugString("Vor Form Load" & Format$(Err.Number))
    
    Call Load(frmMain)
    
    'Call OutputDebugString("Nach Form Load" & Format$(Err.Number))
    
    If Err = 50003 Then
      Dim p As String
      p = App.Path
      If Right$(p, 1) <> "\" Then
        p = p & "\"
      End If

      Call Unload(frmMain)

      'Call Shell("REGSVR32 " & p & "MSCOMM32.OCX")
      
      On Error GoTo 0

      Call Load(frmMain)
    End If

End Sub


Function RemoveEndingBackslash(s As String) As String
  
  If Right$(s, 1) = "\" And Right$(s, 2) <> ":\" Then
    RemoveEndingBackslash = Left$(s, Len(s) - 1)
  Else
    RemoveEndingBackslash = s
  End If

End Function



Sub wait(lngmsec As Long)

Dim sngStart As Single

sngStart = Timer
Do
  DoEvents
Loop Until Timer > sngStart + lngmsec / 1000
  
End Sub

'bringt eine Form in die Mitte des Schrims oder der MDI-Form
Sub CenterForm(f As Form, Optional p)
  
Dim pl As Long, pt As Long, pw As Long, ph As Long

  
  If IsMissing(p) Then
    pl = 0
    pt = 0
    pw = Screen.width
    ph = Screen.Height
  Else
    'Debug.Assert (Not TypeOf p Is Form)
    pl = p.Left
    pt = p.Top
    pw = p.width
    ph = p.Height
  End If

  f.Left = pl + (pw / 2 - f.width / 2) '/ tppx
  f.Top = pt + (ph / 2 - f.Height / 2) '/ tppx

End Sub



Function DialogOpenSave$(f As Form, ByVal ftitle$, fpfad$, ByVal ffile$, ByVal ffilter$, ByVal fext$, SaveFile%)

Dim szFile$, szFilter$, file$
Dim Result As Long

Dim O As OPENFILENAME
Dim wSize As Long
#If Win32 Then
    Dim Memhandle As Long
#Else
    Dim Memhandle As Integer, Address As Long
#End If

szFile$ = ffile$ + String$(128 - Len(ffile$), 0)
szFilter$ = ffilter$ + "||"
Do While InStr(szFilter$, "|")
   szFilter$ = Left$(szFilter$, InStr(szFilter$, "|") - 1) + Chr$(0) + Mid$(szFilter$, InStr(szFilter$, "|") + 1)
Loop

#If Win16 Then
    wSize = Len(szFile$) + Len(szFilter$) + Len(ftitle$) + Len(fpfad$) + Len(fext$) + 3
    Memhandle = GlobalAlloc(GHND, wSize)
    If Memhandle = 0 Then DialogOpenSave$ = "": Exit Function
    Address = GlobalLock(Memhandle)
    Call MemoryCopy(ByVal Address, ByVal (szFile$ + szFilter$ + ftitle$ + Chr$(0) + fpfad$ + Chr$(0) + fext$ + Chr$(0)), wSize)
#End If

O.lStructSize = Len(O)
O.hwndOwner = f.hwnd
O.nFilterIndex = 1
O.nMaxFile = Len(szFile$)

Select Case SaveFile%
Case 0: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
Case 1: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_OVERWRITEPROMPT
Case 2: O.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
End Select

#If Win32 Then
   O.lpstrFile = szFile$
   O.lpstrFilter = szFilter$
   O.lpstrTitle = ftitle$
   O.lpstrDefExt = fext$
   O.lpstrInitialDir = fpfad$
#Else
   O.lpstrFile = Address
   O.lpstrFilter = Address + Len(szFile$)
   O.lpstrTitle = Address + Len(szFile$) + Len(szFilter$)
   O.lpstrInitialDir = Address + Len(szFile$) + Len(szFilter$) + Len(ftitle$) + 1
   O.lpstrDefExt = Address + Len(szFile$) + Len(szFilter$) + Len(ftitle$) + 1 + Len(fpfad$) + 1
#End If

'If SaveFile% = 0 Then
  Result = GetOpenFileName(O)
'Else
'  result = GetSaveFileName(O)
'End If

#If Win16 Then
    If Result <> 0 Then Call MemoryCopy(ByVal szFile$, ByVal Address, Len(szFile$))
    ok = GlobalUnlock(Memhandle)    'Free The Memory
    ok = GlobalFree(Memhandle)
    file$ = Left$(szFile$, InStr(szFile$, Chr$(0)) - 1)
#Else
    file$ = Left$(O.lpstrFile, InStr(O.lpstrFile, Chr$(0)) - 1)
#End If

If Result = 0 Then DialogOpenSave$ = "": Exit Function

fpfad$ = Left$(file$, O.nFileOffset)
DialogOpenSave$ = Right$(file$, Len(file$) - O.nFileOffset)

End Function





Sub Maus(m As Long)

  Screen.MousePointer = m

End Sub


